/*
 ************************************************************************************
 * Copyright (C) 2001-2011 encuestame: system online surveys Copyright (C) 2011
 * encuestame Development Team.
 * Licensed under the Apache Software License version 2.0
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to  in writing,  software  distributed
 * under the License is distributed  on  an  "AS IS"  BASIS,  WITHOUT  WARRANTIES  OR
 * CONDITIONS OF ANY KIND, either  express  or  implied.  See  the  License  for  the
 * specific language governing permissions and limitations under the License.
 ************************************************************************************
 */
package org.encuestame.oauth.security;

import org.encuestame.utils.oauth.OAuthSession;
import org.springframework.security.oauth.provider.token.OAuthProviderToken;

/**
 * Adapts a {@link OAuthSession} returned by the {@link OAuthSessionManager}
 * to a Spring Security {@link OAuthProviderToken}.
 * @author Picado, Juan juanATencuestame.org
 * @since Dec 24, 2010 3:57:14 PM
 * @version Id:
 */
@SuppressWarnings("serial")
class OAuthSessionProviderToken implements OAuthProviderToken {

    private OAuthSession session;

    public OAuthSessionProviderToken(OAuthSession session) {
        this.session = session;
    }

    public String getConsumerKey() {
        return session.getApiKey();
    }

    public String getValue() {
        return session.getRequestToken();
    }

    public String getSecret() {
        return session.getSecret();
    }

    public String getCallbackUrl() {
        return session.getCallbackUrl();
    }

    public String getVerifier() {
        return session.getVerifier();
    }

    public boolean isAccessToken() {
        return false;
    }
}